program WinExit;

uses
  XReboot, Windows;

{$R *.RES}

var
  Reboot: TXWinReboot;
  Param: string;

procedure Help;
begin
  MessageBox(0,
    'CICOM WinExit 1.0 copyright  2000 Michal Cihar'#13+
    'You can use WinExit with following parameters:'#13+
    '/l ... Log off'#13 +
    '/r ... Reboot'#13 +
    '/p ... Power off'#13 +
    '/d ... shutDown'#13 +
    '/s ... Suspend'#13 +
    '/h ... Hibernate'#13 +
    '/ and - are equal'#13 +
    'Small letter mean normal, big force termination of processes'#13#13 +
    'Made by Michal Cihar <cihar@email.cz>, Public domnain'#13 +
    'Homepage: http://cicom.tsx.org'
    , 'Valid parameters', MB_OK + MB_ICONINFORMATION);
  Halt;
end;

begin
  if Paramcount = 0 then
  begin
    MessageBox(0, 'You must specify at least one parameter!', 'Use parameters!', MB_OK + MB_ICONINFORMATION);
    Help;
  end;
  Param := Paramstr(1);
  if (Paramcount > 1) or (Length(Param) <> 2) or ((Param[1] <> '/') and (Param[1] <> '-')) then
  begin
    MessageBox(0, 'Given parameters doesnt''t seem to be valid!', 'Bad parameters!', MB_OK + MB_ICONWARNING);
    Help;
  end;

  Reboot := TXWinReboot.Create(nil);

  case Param[2] of
    'L': begin Reboot.Operation := roLogOff; Reboot.ForceTerminateProcesses := true; end;
    'R': begin Reboot.Operation := roReboot; Reboot.ForceTerminateProcesses := true; end;
    'P': begin Reboot.Operation := roShutDown; Reboot.PowerOff := true; Reboot.ForceTerminateProcesses := true; end;
    'D': begin Reboot.Operation := roShutDown; Reboot.PowerOff := false; Reboot.ForceTerminateProcesses := true; end;
    'S': begin Reboot.Operation := roSuspend; Reboot.ForceTerminateProcesses := true; end;
    'H': begin Reboot.Operation := roHibernate; Reboot.ForceTerminateProcesses := true; end;

    'l': begin Reboot.Operation := roLogOff; Reboot.ForceTerminateProcesses := false; end;
    'r': begin Reboot.Operation := roReboot; Reboot.ForceTerminateProcesses := false; end;
    'p': begin Reboot.Operation := roShutDown; Reboot.PowerOff := true; Reboot.ForceTerminateProcesses := false; end;
    'd': begin Reboot.Operation := roShutDown; Reboot.PowerOff := false; Reboot.ForceTerminateProcesses := false; end;
    's': begin Reboot.Operation := roSuspend; Reboot.ForceTerminateProcesses := false; end;
    'h': begin Reboot.Operation := roHibernate; Reboot.ForceTerminateProcesses := false; end;
  else
    begin
      MessageBox(0, 'Given parameters doesnt''t seem to be valid!', 'Bad parameters!', MB_OK + MB_ICONWARNING);
      Help;
    end;
  end;
  Reboot.Execute;
  Reboot.Free;
end.

